<?php
/**
 * Copyright © 2015 FiloBlu. All rights reserved.
 */

namespace FiloBlu\Flow\Model;

use Magento\Framework\Exception\InboundflowException;

/**
 * Inboundflowtab inboundflow model
 */
class Channel extends \Magento\Framework\Model\AbstractModel
{

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {
        parent::__construct($context, $registry, $resource, $resourceCollection,$data);
    }

    /**
     * @return void
     */
    public function _construct()
    {
        $this->_init('FiloBlu\Flow\Model\ResourceModel\Channel');
    }

    /**
     * Load object data
     *
     * @param   integer $id
     * @return  Mage_Core_Model_Abstract
     */
    public function load($id, $field=null)
    {
        parent::load($id,$field);

        $json = $this->getData('data');

        try {
            $object =json_decode($json,false);
        }
        catch (\Exception $e) {

            $this->_messageManager->addError($e->getMessage());
            return $this;
        }

        if (isset($object->config))
            $this->setData('config', (Array)$object->config);

        if (isset($object->connector))
            $this->setData('connector', (Array)$object->connector);

        if (isset($object->parser))
            $this->setData('parser', (Array)$object->parser);

        if (isset($object->map))
            $this->setData('map',  json_encode($object->map));

        return $this;
    }

    /**
     * Save object data
     *
     * @return Mage_Core_Model_Abstract
     */
    public function save()
    {

        $data = $this->getData();

        $obj = new \stdClass();

        if ($data['config'])
            $obj->config = (object) $data['config'];

        if ($data['connector'])
            $obj->connector = (object) $data['connector'];

        if ($data['parser'])
            $obj->parser = (object) $data['parser'];

        if ($data['map'])
            $obj->map = json_decode($data['map'],JSON_FORCE_OBJECT);

        $obj_decoded = str_replace('null','', json_encode($obj));

        $this->setData('data', $obj_decoded);

        return parent::save();

    }

}