<?php
namespace FiloBlu\Flow\Model;

class Map{

    public $initialized = false;
    public $file = "map.json";
    protected $mappedData = array();
    /**
    * @var Monolog\Logger
    */
    protected $_logger;

    public function __construct(
            \FiloBlu\Flow\Helper\LoggerProvider $_loggerProvider
    )
    {

        $this->_logger = $_loggerProvider->getLogger();

    }

    public function load($channel) {

        $model_channel = \Magento\Framework\App\ObjectManager::getInstance()->create('FiloBlu\Flow\Model\Channel');
        $model_channel->load($channel,'name');



        if($model_channel){

            try {
                $json_content = str_replace(array("\n", "\t", "\r"), '', $model_channel->getData('data'));
                $mapped_config = json_decode($json_content,true);
                $this->mappedData = $mapped_config['map'];
                $this->initialized = true;
                $this->_logger->info("Config "."Loaded map json file");
            }catch(\Exception $e){
                $this->_logger->info("Config "."Fail to load map json file");
            }
        }else{
            $this->_logger->info("Config","File for channel data not exist for json map");
        }

    }

    public function get($field){
        if(isset($this->mappedData[$field])){
            return $this->mappedData[$field];
        }
        return null;
    }

    public function getFields(){
        return array_keys($this->mappedData);
    }

    public function checkData($data){
        
        if(count($data) == count($this->mappedData)){
            return true;
        }
        return false;
    }

}