<?php
/**
 * Copyright © 2015 FiloBlu. All rights reserved.
 */

namespace FiloBlu\Flow\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;
/**
 * @codeCoverageIgnore
 */
class UpgradeSchema implements UpgradeSchemaInterface
{
    /**
     * {@inheritdoc}
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        
        $setup->startSetup();

        if(!$context->getVersion()) {
            
        }

        if (version_compare($context->getVersion(), '0.0.7') < 0) {
              $this->createIndexOnFlowFromItem($setup, $context);
        }
        
        if (version_compare($context->getVersion(), '0.0.8') < 0) {
              $this->createFlowFromStockTable($setup, $context);
        }
        
        if (version_compare($context->getVersion(), '0.0.9') < 0) {
             //
        }

        $setup->endSetup();

    }

     public function createIndexOnFlowFromItem(SchemaSetupInterface $setup, ModuleContextInterface $context)
        {
            try{
                $setup->getConnection()->query("ALTER TABLE `flow_inboundflow` ADD INDEX `FILENAME` (`name`(255));");
            } catch(\Exception $e) {
                throw new \Exception("Error Processing Request - add index in flow_from_ite table. " . $e->getMessage() , 1);
            }
        }
        
     public function createFlowFromStockTable(SchemaSetupInterface $setup, ModuleContextInterface $context)
        {
         
          /**
           * Create table 'flow_from_stock' if not exists
           */

          if (!$setup->tableExists('flow_from_stock')) {

              $table = $setup->getConnection()->newTable(
                  $setup->getTable('flow_from_stock')
              )
                  ->addColumn(
                        'sku',
                        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                        '40',
                        [],
                        'sku'
                  )
                  ->addColumn(
                        'magazzino',
                        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                        '30',
                        [],
                        'magazzino'
                  )
                  ->addColumn(
                        'fisico_disponibile',
                        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                        '10',
                        [],
                        'qta disponibile in magazzino - aggiornamento in sovrascrittura'
                  )
                  ->addColumn(
                        'meta_id',
                        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                        null,
                        ['identity' => true, 'unsigned' => true, 'nullable' => false, 'primary' => true],
                        'id'
                    )
                  ->addColumn(
                        'meta_processed',
                        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                        '1',
                        [],
                        'meta_processed'
                    )
                  ->addColumn(
                        'meta_process_time',
                        \Magento\Framework\DB\Ddl\Table::TYPE_DATETIME,
                        '10',
                        [],
                        'meta_process_time'
                    )

                  ->setComment(
                      'FiloBlu Flow flow_from_stock'
                  );

              $setup->getConnection()->createTable($table);


          }

         
        }

}
